# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.
#
"""
This is a very basic Elisa client which makes use of the meta_fs plugin.
"""

from twisted.spread import pb
from twisted.internet import reactor
import sys

def process(children):
    print children
    reactor.stop()

def main():
    factory = pb.PBClientFactory()
    reactor.connectTCP("localhost", 8789, factory)
    d = factory.getRootObject()
    d.addCallback(lambda object: object.callRemote("get_plugin_manager"))
    d.addCallback(lambda manager: manager.callRemote('get_plugin_with_name',
                                                     'meta_fs'))
    d.addCallback(lambda plugin: plugin.callRemote('get_direct_children',
                                                   'meta://artist:list'))
    d.addCallback(lambda children: process(children))
    reactor.run()
    return 0

if __name__ == '__main__':
    sys.exit(main())
